/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface GetBlockResponseState {
    active: boolean;
    entered: boolean;
    exited: boolean;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare type GetBlockResponseType = "custom" | "card" | "modal" | "checklist" | "checklistItem" | "hints" | "hintsItem" | "tour" | "tourItem";
declare const GetBlockResponseType: {
    readonly Custom: "custom";
    readonly Card: "card";
    readonly Modal: "modal";
    readonly Checklist: "checklist";
    readonly ChecklistItem: "checklistItem";
    readonly Hints: "hints";
    readonly HintsItem: "hintsItem";
    readonly Tour: "tour";
    readonly TourItem: "tourItem";
};

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface GetBlockResponseFieldsItemString {
    sid: string;
    value?: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface GetBlockResponseFieldsItemNumber {
    sid: string;
    value?: number;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface GetBlockResponseFieldsItemBoolean {
    sid: string;
    value?: boolean;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface GetBlockResponseFieldsItemRichText {
    sid: string;
    value?: Record<string, unknown>[];
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare type GetBlockResponseFieldsItem = GetBlockResponseFieldsItem.String | GetBlockResponseFieldsItem.Number | GetBlockResponseFieldsItem.Boolean | GetBlockResponseFieldsItem.RichText;
declare namespace GetBlockResponseFieldsItem {
    interface String extends GetBlockResponseFieldsItemString {
        type: "string";
    }
    interface Number extends GetBlockResponseFieldsItemNumber {
        type: "number";
    }
    interface Boolean extends GetBlockResponseFieldsItemBoolean {
        type: "boolean";
    }
    interface RichText extends GetBlockResponseFieldsItemRichText {
        type: "richText";
    }
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

interface GetBlockResponse {
    kind: "block";
    uid: string;
    sid: string;
    version: number;
    state: GetBlockResponseState;
    containerUid?: string;
    transitioned: Record<string, boolean>;
    type: GetBlockResponseType;
    fields: GetBlockResponseFieldsItem[];
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
/**
 * @example
 *     {
 *         userIdentifier: "userIdentifier",
 *         version: 1.1
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1
 *     }
 */
interface GetBlockRequest {
    userIdentifier: string;
    groupIdentifier?: string;
    version: number;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
/**
 * @example
 *     {
 *         transitions: "string",
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1
 *     }
 *
 * @example
 *     {
 *         transitions: "string",
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1
 *     }
 *
 * @example
 *     {
 *         transitions: "string",
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1
 *     }
 *
 * @example
 *     {
 *         transitions: "string",
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1
 *     }
 *
 * @example
 *     {
 *         transitions: "string",
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1
 *     }
 */
interface TransitionRequest {
    transitions?: string | string[];
    userIdentifier: string;
    groupIdentifier?: string;
    version: number;
}

type index$2_GetBlockRequest = GetBlockRequest;
type index$2_GetBlockResponse = GetBlockResponse;
declare const index$2_GetBlockResponseFieldsItem: typeof GetBlockResponseFieldsItem;
type index$2_GetBlockResponseFieldsItemBoolean = GetBlockResponseFieldsItemBoolean;
type index$2_GetBlockResponseFieldsItemNumber = GetBlockResponseFieldsItemNumber;
type index$2_GetBlockResponseFieldsItemRichText = GetBlockResponseFieldsItemRichText;
type index$2_GetBlockResponseFieldsItemString = GetBlockResponseFieldsItemString;
type index$2_GetBlockResponseState = GetBlockResponseState;
declare const index$2_GetBlockResponseType: typeof GetBlockResponseType;
type index$2_TransitionRequest = TransitionRequest;
declare namespace index$2 {
  export {
    index$2_GetBlockRequest as GetBlockRequest,
    index$2_GetBlockResponse as GetBlockResponse,
    index$2_GetBlockResponseFieldsItem as GetBlockResponseFieldsItem,
    index$2_GetBlockResponseFieldsItemBoolean as GetBlockResponseFieldsItemBoolean,
    index$2_GetBlockResponseFieldsItemNumber as GetBlockResponseFieldsItemNumber,
    index$2_GetBlockResponseFieldsItemRichText as GetBlockResponseFieldsItemRichText,
    index$2_GetBlockResponseFieldsItemString as GetBlockResponseFieldsItemString,
    index$2_GetBlockResponseState as GetBlockResponseState,
    index$2_GetBlockResponseType as GetBlockResponseType,
    index$2_TransitionRequest as TransitionRequest,
  };
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare type GetFlowRequestTag = "uncommitted" | "latest";
declare const GetFlowRequestTag: {
    readonly Uncommitted: "uncommitted";
    readonly Latest: "latest";
};

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface GetFlowResponseState {
    stopped: boolean;
    started: boolean;
    finished: boolean;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface GetFlowResponseBlocksItemState {
    active: boolean;
    entered: boolean;
    exited: boolean;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare type GetFlowResponseBlocksItemType = "custom" | "card" | "modal" | "checklist" | "checklistItem" | "hints" | "hintsItem" | "tour" | "tourItem";
declare const GetFlowResponseBlocksItemType: {
    readonly Custom: "custom";
    readonly Card: "card";
    readonly Modal: "modal";
    readonly Checklist: "checklist";
    readonly ChecklistItem: "checklistItem";
    readonly Hints: "hints";
    readonly HintsItem: "hintsItem";
    readonly Tour: "tour";
    readonly TourItem: "tourItem";
};

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface GetFlowResponseBlocksItemFieldsItemString {
    sid: string;
    value?: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface GetFlowResponseBlocksItemFieldsItemNumber {
    sid: string;
    value?: number;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface GetFlowResponseBlocksItemFieldsItemBoolean {
    sid: string;
    value?: boolean;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface GetFlowResponseBlocksItemFieldsItemRichText {
    sid: string;
    value?: Record<string, unknown>[];
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare type GetFlowResponseBlocksItemFieldsItem = GetFlowResponseBlocksItemFieldsItem.String | GetFlowResponseBlocksItemFieldsItem.Number | GetFlowResponseBlocksItemFieldsItem.Boolean | GetFlowResponseBlocksItemFieldsItem.RichText;
declare namespace GetFlowResponseBlocksItemFieldsItem {
    interface String extends GetFlowResponseBlocksItemFieldsItemString {
        type: "string";
    }
    interface Number extends GetFlowResponseBlocksItemFieldsItemNumber {
        type: "number";
    }
    interface Boolean extends GetFlowResponseBlocksItemFieldsItemBoolean {
        type: "boolean";
    }
    interface RichText extends GetFlowResponseBlocksItemFieldsItemRichText {
        type: "richText";
    }
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

interface GetFlowResponseBlocksItem {
    kind: "block";
    uid: string;
    sid: string;
    version: number;
    state: GetFlowResponseBlocksItemState;
    containerUid?: string;
    transitioned: Record<string, boolean>;
    type: GetFlowResponseBlocksItemType;
    fields: GetFlowResponseBlocksItemFieldsItem[];
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

interface GetFlowResponse {
    kind: "flow";
    type: "flow";
    uid: string;
    sid: string;
    version: number;
    state: GetFlowResponseState;
    blocks?: GetFlowResponseBlocksItem[];
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare type IntentRequestIntent = "finish" | "stop" | "reset" | "start";
declare const IntentRequestIntent: {
    readonly Finish: "finish";
    readonly Stop: "stop";
    readonly Reset: "reset";
    readonly Start: "start";
};

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare type IntentRequestTag = "uncommitted" | "latest";
declare const IntentRequestTag: {
    readonly Uncommitted: "uncommitted";
    readonly Latest: "latest";
};

/**
 * This file was auto-generated by Fern from our API Definition.
 */

/**
 * @example
 *     {
 *         userIdentifier: "userIdentifier"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1,
 *         tag: DoptApi.GetFlowRequestTag.Uncommitted,
 *         include: "block"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1,
 *         tag: DoptApi.GetFlowRequestTag.Uncommitted,
 *         include: "block"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1,
 *         tag: DoptApi.GetFlowRequestTag.Uncommitted,
 *         include: "block"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1,
 *         tag: DoptApi.GetFlowRequestTag.Uncommitted,
 *         include: "block"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1,
 *         tag: DoptApi.GetFlowRequestTag.Uncommitted,
 *         include: "block"
 *     }
 */
interface GetFlowRequest {
    userIdentifier: string;
    groupIdentifier?: string;
    version?: number;
    tag?: GetFlowRequestTag;
    include?: "block";
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

/**
 * @example
 *     {
 *         userIdentifier: "userIdentifier"
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1,
 *         tag: DoptApi.IntentRequestTag.Uncommitted,
 *         force: true
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1,
 *         tag: DoptApi.IntentRequestTag.Uncommitted,
 *         force: true
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1,
 *         tag: DoptApi.IntentRequestTag.Uncommitted,
 *         force: true
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1,
 *         tag: DoptApi.IntentRequestTag.Uncommitted,
 *         force: true
 *     }
 *
 * @example
 *     {
 *         userIdentifier: "string",
 *         groupIdentifier: "string",
 *         version: 1.1,
 *         tag: DoptApi.IntentRequestTag.Uncommitted,
 *         force: true
 *     }
 */
interface IntentRequest {
    userIdentifier: string;
    groupIdentifier?: string;
    version?: number;
    tag?: IntentRequestTag;
    force?: boolean;
}

type index$1_GetFlowRequest = GetFlowRequest;
declare const index$1_GetFlowRequestTag: typeof GetFlowRequestTag;
type index$1_GetFlowResponse = GetFlowResponse;
type index$1_GetFlowResponseBlocksItem = GetFlowResponseBlocksItem;
declare const index$1_GetFlowResponseBlocksItemFieldsItem: typeof GetFlowResponseBlocksItemFieldsItem;
type index$1_GetFlowResponseBlocksItemFieldsItemBoolean = GetFlowResponseBlocksItemFieldsItemBoolean;
type index$1_GetFlowResponseBlocksItemFieldsItemNumber = GetFlowResponseBlocksItemFieldsItemNumber;
type index$1_GetFlowResponseBlocksItemFieldsItemRichText = GetFlowResponseBlocksItemFieldsItemRichText;
type index$1_GetFlowResponseBlocksItemFieldsItemString = GetFlowResponseBlocksItemFieldsItemString;
type index$1_GetFlowResponseBlocksItemState = GetFlowResponseBlocksItemState;
declare const index$1_GetFlowResponseBlocksItemType: typeof GetFlowResponseBlocksItemType;
type index$1_GetFlowResponseState = GetFlowResponseState;
type index$1_IntentRequest = IntentRequest;
declare const index$1_IntentRequestIntent: typeof IntentRequestIntent;
declare const index$1_IntentRequestTag: typeof IntentRequestTag;
declare namespace index$1 {
  export {
    index$1_GetFlowRequest as GetFlowRequest,
    index$1_GetFlowRequestTag as GetFlowRequestTag,
    index$1_GetFlowResponse as GetFlowResponse,
    index$1_GetFlowResponseBlocksItem as GetFlowResponseBlocksItem,
    index$1_GetFlowResponseBlocksItemFieldsItem as GetFlowResponseBlocksItemFieldsItem,
    index$1_GetFlowResponseBlocksItemFieldsItemBoolean as GetFlowResponseBlocksItemFieldsItemBoolean,
    index$1_GetFlowResponseBlocksItemFieldsItemNumber as GetFlowResponseBlocksItemFieldsItemNumber,
    index$1_GetFlowResponseBlocksItemFieldsItemRichText as GetFlowResponseBlocksItemFieldsItemRichText,
    index$1_GetFlowResponseBlocksItemFieldsItemString as GetFlowResponseBlocksItemFieldsItemString,
    index$1_GetFlowResponseBlocksItemState as GetFlowResponseBlocksItemState,
    index$1_GetFlowResponseBlocksItemType as GetFlowResponseBlocksItemType,
    index$1_GetFlowResponseState as GetFlowResponseState,
    index$1_IntentRequest as IntentRequest,
    index$1_IntentRequestIntent as IntentRequestIntent,
    index$1_IntentRequestTag as IntentRequestTag,
  };
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface BadRequestErrorResponseBody {
    code: "invalid_request_error";
    details: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface BlockTransitionQueryString {
    transitions: string[];
    userIdentifier: string;
    groupIdentifier?: string;
    version: number;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface BlockTransitionRequestBody {
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface BlockTransitionRequestParams {
    uid: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare type FlowIntentQueryStringTag = "uncommitted" | "latest";
declare const FlowIntentQueryStringTag: {
    readonly Uncommitted: "uncommitted";
    readonly Latest: "latest";
};

/**
 * This file was auto-generated by Fern from our API Definition.
 */

interface FlowIntentQueryString {
    userIdentifier: string;
    groupIdentifier?: string;
    version?: number;
    tag?: FlowIntentQueryStringTag;
    force?: boolean;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface FlowIntentRequestBody {
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare type FlowIntentRequestParamsIntent = "finish" | "stop" | "reset" | "start";
declare const FlowIntentRequestParamsIntent: {
    readonly Finish: "finish";
    readonly Stop: "stop";
    readonly Reset: "reset";
    readonly Start: "start";
};

/**
 * This file was auto-generated by Fern from our API Definition.
 */

interface FlowIntentRequestParams {
    sid: string;
    intent: FlowIntentRequestParamsIntent;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface GetBlockQueryString {
    userIdentifier: string;
    groupIdentifier?: string;
    version: number;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface GetBlockRequestParams {
    uid: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare type GetFlowQueryStringTag = "uncommitted" | "latest";
declare const GetFlowQueryStringTag: {
    readonly Uncommitted: "uncommitted";
    readonly Latest: "latest";
};

/**
 * This file was auto-generated by Fern from our API Definition.
 */

interface GetFlowQueryString {
    userIdentifier: string;
    groupIdentifier?: string;
    version?: number;
    tag?: GetFlowQueryStringTag;
    include?: "block";
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface GetFlowRequestParams {
    sid: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface HealthCheckResponseBody {
    application: string;
    status: number;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface InternalServerErrorResponseBody {
    code: "internal_server_error";
    details: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface NotFoundErrorResponseBody {
    code: "not_found_error";
    details: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface TimeoutErrorResponseBody {
    code: "internal_server_error";
    details: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface UnauthorizedErrorResponseBody {
    code: "unauthorized_error";
    details: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
interface UserIdentifierParams {
    userIdentifier: string;
    groupIdentifier?: string;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare class DoptApiError extends Error {
    readonly statusCode?: number;
    readonly body?: unknown;
    constructor({ message, statusCode, body }: {
        message?: string;
        statusCode?: number;
        body?: unknown;
    });
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare class DoptApiTimeoutError extends Error {
    constructor();
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare class BadRequestError extends DoptApiError {
    constructor(body?: unknown);
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare class UnauthorizedError extends DoptApiError {
    constructor(body?: unknown);
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare class NotFoundError extends DoptApiError {
    constructor(body?: unknown);
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare class InternalServerError extends DoptApiError {
    constructor(body?: unknown);
}

type index_BadRequestError = BadRequestError;
declare const index_BadRequestError: typeof BadRequestError;
type index_BadRequestErrorResponseBody = BadRequestErrorResponseBody;
type index_BlockTransitionQueryString = BlockTransitionQueryString;
type index_BlockTransitionRequestBody = BlockTransitionRequestBody;
type index_BlockTransitionRequestParams = BlockTransitionRequestParams;
type index_FlowIntentQueryString = FlowIntentQueryString;
declare const index_FlowIntentQueryStringTag: typeof FlowIntentQueryStringTag;
type index_FlowIntentRequestBody = FlowIntentRequestBody;
type index_FlowIntentRequestParams = FlowIntentRequestParams;
declare const index_FlowIntentRequestParamsIntent: typeof FlowIntentRequestParamsIntent;
type index_GetBlockQueryString = GetBlockQueryString;
type index_GetBlockRequest = GetBlockRequest;
type index_GetBlockRequestParams = GetBlockRequestParams;
type index_GetBlockResponse = GetBlockResponse;
declare const index_GetBlockResponseFieldsItem: typeof GetBlockResponseFieldsItem;
type index_GetBlockResponseFieldsItemBoolean = GetBlockResponseFieldsItemBoolean;
type index_GetBlockResponseFieldsItemNumber = GetBlockResponseFieldsItemNumber;
type index_GetBlockResponseFieldsItemRichText = GetBlockResponseFieldsItemRichText;
type index_GetBlockResponseFieldsItemString = GetBlockResponseFieldsItemString;
type index_GetBlockResponseState = GetBlockResponseState;
declare const index_GetBlockResponseType: typeof GetBlockResponseType;
type index_GetFlowQueryString = GetFlowQueryString;
declare const index_GetFlowQueryStringTag: typeof GetFlowQueryStringTag;
type index_GetFlowRequest = GetFlowRequest;
type index_GetFlowRequestParams = GetFlowRequestParams;
declare const index_GetFlowRequestTag: typeof GetFlowRequestTag;
type index_GetFlowResponse = GetFlowResponse;
type index_GetFlowResponseBlocksItem = GetFlowResponseBlocksItem;
declare const index_GetFlowResponseBlocksItemFieldsItem: typeof GetFlowResponseBlocksItemFieldsItem;
type index_GetFlowResponseBlocksItemFieldsItemBoolean = GetFlowResponseBlocksItemFieldsItemBoolean;
type index_GetFlowResponseBlocksItemFieldsItemNumber = GetFlowResponseBlocksItemFieldsItemNumber;
type index_GetFlowResponseBlocksItemFieldsItemRichText = GetFlowResponseBlocksItemFieldsItemRichText;
type index_GetFlowResponseBlocksItemFieldsItemString = GetFlowResponseBlocksItemFieldsItemString;
type index_GetFlowResponseBlocksItemState = GetFlowResponseBlocksItemState;
declare const index_GetFlowResponseBlocksItemType: typeof GetFlowResponseBlocksItemType;
type index_GetFlowResponseState = GetFlowResponseState;
type index_HealthCheckResponseBody = HealthCheckResponseBody;
type index_IntentRequest = IntentRequest;
declare const index_IntentRequestIntent: typeof IntentRequestIntent;
declare const index_IntentRequestTag: typeof IntentRequestTag;
type index_InternalServerError = InternalServerError;
declare const index_InternalServerError: typeof InternalServerError;
type index_InternalServerErrorResponseBody = InternalServerErrorResponseBody;
type index_NotFoundError = NotFoundError;
declare const index_NotFoundError: typeof NotFoundError;
type index_NotFoundErrorResponseBody = NotFoundErrorResponseBody;
type index_TimeoutErrorResponseBody = TimeoutErrorResponseBody;
type index_TransitionRequest = TransitionRequest;
type index_UnauthorizedError = UnauthorizedError;
declare const index_UnauthorizedError: typeof UnauthorizedError;
type index_UnauthorizedErrorResponseBody = UnauthorizedErrorResponseBody;
type index_UserIdentifierParams = UserIdentifierParams;
declare namespace index {
  export {
    index_BadRequestError as BadRequestError,
    index_BadRequestErrorResponseBody as BadRequestErrorResponseBody,
    index_BlockTransitionQueryString as BlockTransitionQueryString,
    index_BlockTransitionRequestBody as BlockTransitionRequestBody,
    index_BlockTransitionRequestParams as BlockTransitionRequestParams,
    index_FlowIntentQueryString as FlowIntentQueryString,
    index_FlowIntentQueryStringTag as FlowIntentQueryStringTag,
    index_FlowIntentRequestBody as FlowIntentRequestBody,
    index_FlowIntentRequestParams as FlowIntentRequestParams,
    index_FlowIntentRequestParamsIntent as FlowIntentRequestParamsIntent,
    index_GetBlockQueryString as GetBlockQueryString,
    index_GetBlockRequest as GetBlockRequest,
    index_GetBlockRequestParams as GetBlockRequestParams,
    index_GetBlockResponse as GetBlockResponse,
    index_GetBlockResponseFieldsItem as GetBlockResponseFieldsItem,
    index_GetBlockResponseFieldsItemBoolean as GetBlockResponseFieldsItemBoolean,
    index_GetBlockResponseFieldsItemNumber as GetBlockResponseFieldsItemNumber,
    index_GetBlockResponseFieldsItemRichText as GetBlockResponseFieldsItemRichText,
    index_GetBlockResponseFieldsItemString as GetBlockResponseFieldsItemString,
    index_GetBlockResponseState as GetBlockResponseState,
    index_GetBlockResponseType as GetBlockResponseType,
    index_GetFlowQueryString as GetFlowQueryString,
    index_GetFlowQueryStringTag as GetFlowQueryStringTag,
    index_GetFlowRequest as GetFlowRequest,
    index_GetFlowRequestParams as GetFlowRequestParams,
    index_GetFlowRequestTag as GetFlowRequestTag,
    index_GetFlowResponse as GetFlowResponse,
    index_GetFlowResponseBlocksItem as GetFlowResponseBlocksItem,
    index_GetFlowResponseBlocksItemFieldsItem as GetFlowResponseBlocksItemFieldsItem,
    index_GetFlowResponseBlocksItemFieldsItemBoolean as GetFlowResponseBlocksItemFieldsItemBoolean,
    index_GetFlowResponseBlocksItemFieldsItemNumber as GetFlowResponseBlocksItemFieldsItemNumber,
    index_GetFlowResponseBlocksItemFieldsItemRichText as GetFlowResponseBlocksItemFieldsItemRichText,
    index_GetFlowResponseBlocksItemFieldsItemString as GetFlowResponseBlocksItemFieldsItemString,
    index_GetFlowResponseBlocksItemState as GetFlowResponseBlocksItemState,
    index_GetFlowResponseBlocksItemType as GetFlowResponseBlocksItemType,
    index_GetFlowResponseState as GetFlowResponseState,
    index_HealthCheckResponseBody as HealthCheckResponseBody,
    index_IntentRequest as IntentRequest,
    index_IntentRequestIntent as IntentRequestIntent,
    index_IntentRequestTag as IntentRequestTag,
    index_InternalServerError as InternalServerError,
    index_InternalServerErrorResponseBody as InternalServerErrorResponseBody,
    index_NotFoundError as NotFoundError,
    index_NotFoundErrorResponseBody as NotFoundErrorResponseBody,
    index_TimeoutErrorResponseBody as TimeoutErrorResponseBody,
    index_TransitionRequest as TransitionRequest,
    index_UnauthorizedError as UnauthorizedError,
    index_UnauthorizedErrorResponseBody as UnauthorizedErrorResponseBody,
    index_UserIdentifierParams as UserIdentifierParams,
    index$2 as blocks,
    index$1 as flows,
  };
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */
declare const DoptApiEnvironment: {
    readonly Default: "https://blocks.dopt.com";
};
declare type DoptApiEnvironment = typeof DoptApiEnvironment.Default;

declare type Supplier<T> = T | Promise<T> | (() => T | Promise<T>);
declare const Supplier: {
    get: <T>(supplier: Supplier<T>) => Promise<T>;
};

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare namespace Blocks {
    interface Options {
        environment?: Supplier<DoptApiEnvironment | string>;
        apiKey: Supplier<string>;
    }
    interface RequestOptions {
        timeoutInSeconds?: number;
        maxRetries?: number;
    }
}
declare class Blocks {
    protected readonly _options: Blocks.Options;
    constructor(_options: Blocks.Options);
    /**
     * @throws {@link DoptApi.BadRequestError}
     * @throws {@link DoptApi.UnauthorizedError}
     * @throws {@link DoptApi.NotFoundError}
     * @throws {@link DoptApi.InternalServerError}
     *
     * @example
     *     await doptApi.blocks.getBlock("uid", {
     *         userIdentifier: "userIdentifier",
     *         version: 1.1
     *     })
     *
     * @example
     *     await doptApi.blocks.getBlock("string", {
     *         userIdentifier: "string",
     *         groupIdentifier: "string",
     *         version: 1.1
     *     })
     */
    getBlock(uid: string, request: GetBlockRequest, requestOptions?: Blocks.RequestOptions): Promise<GetBlockResponse>;
    /**
     * @throws {@link DoptApi.BadRequestError}
     * @throws {@link DoptApi.UnauthorizedError}
     * @throws {@link DoptApi.NotFoundError}
     * @throws {@link DoptApi.InternalServerError}
     *
     * @example
     *     await doptApi.blocks.transition("string", {
     *         transitions: "string",
     *         userIdentifier: "string",
     *         groupIdentifier: "string",
     *         version: 1.1
     *     })
     */
    transition(uid: string, request: TransitionRequest, requestOptions?: Blocks.RequestOptions): Promise<void>;
    protected _getCustomAuthorizationHeaders(): Promise<{
        "x-api-key": string;
    }>;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare namespace Flows {
    interface Options {
        environment?: Supplier<DoptApiEnvironment | string>;
        apiKey: Supplier<string>;
    }
    interface RequestOptions {
        timeoutInSeconds?: number;
        maxRetries?: number;
    }
}
declare class Flows {
    protected readonly _options: Flows.Options;
    constructor(_options: Flows.Options);
    /**
     * @throws {@link DoptApi.BadRequestError}
     * @throws {@link DoptApi.UnauthorizedError}
     * @throws {@link DoptApi.NotFoundError}
     * @throws {@link DoptApi.InternalServerError}
     *
     * @example
     *     await doptApi.flows.getFlow("sid", {
     *         userIdentifier: "userIdentifier"
     *     })
     *
     * @example
     *     await doptApi.flows.getFlow("string", {
     *         userIdentifier: "string",
     *         groupIdentifier: "string",
     *         version: 1.1,
     *         tag: DoptApi.GetFlowRequestTag.Uncommitted,
     *         include: "block"
     *     })
     */
    getFlow(sid: string, request: GetFlowRequest, requestOptions?: Flows.RequestOptions): Promise<GetFlowResponse>;
    /**
     * @throws {@link DoptApi.BadRequestError}
     * @throws {@link DoptApi.UnauthorizedError}
     * @throws {@link DoptApi.NotFoundError}
     * @throws {@link DoptApi.InternalServerError}
     *
     * @example
     *     await doptApi.flows.intent("sid", DoptApi.IntentRequestIntent.Finish, {
     *         userIdentifier: "userIdentifier"
     *     })
     *
     * @example
     *     await doptApi.flows.intent("string", DoptApi.IntentRequestIntent.Finish, {
     *         userIdentifier: "string",
     *         groupIdentifier: "string",
     *         version: 1.1,
     *         tag: DoptApi.IntentRequestTag.Uncommitted,
     *         force: true
     *     })
     */
    intent(sid: string, intent: IntentRequestIntent, request: IntentRequest, requestOptions?: Flows.RequestOptions): Promise<void>;
    protected _getCustomAuthorizationHeaders(): Promise<{
        "x-api-key": string;
    }>;
}

/**
 * This file was auto-generated by Fern from our API Definition.
 */

declare namespace DoptApiClient {
    interface Options {
        environment?: Supplier<DoptApiEnvironment | string>;
        apiKey: Supplier<string>;
    }
    interface RequestOptions {
        timeoutInSeconds?: number;
        maxRetries?: number;
    }
}
declare class DoptApiClient {
    protected readonly _options: DoptApiClient.Options;
    constructor(_options: DoptApiClient.Options);
    protected _blocks: Blocks | undefined;
    get blocks(): Blocks;
    protected _flows: Flows | undefined;
    get flows(): Flows;
}

export { index as DoptApi, DoptApiClient, DoptApiEnvironment, DoptApiError, DoptApiTimeoutError };
